#include "BoiteAOutils.h"
#include <wx/intl.h>
#include <wx/tooltip.h>
//---------------------------------------------------------------------------
// Utilitaires divers
//---------------------------------------------------------------------------
// Emulation de la fonction RandomRange
// retourne un entier dans l'intervalle [low, High[
int RandomRange_bis(int low,int high)
{
        if (high <low) high=low;
        return (rand() % (high-low))+low;
}
//---------------------------------------------------------------------------
//      Implémentation de l'objet Traducteur
//---------------------------------------------------------------------------
        void Traducteur::ajoute_une_entree(wxString Tf,wxString Ta,wxString Te)
{
        Dictionnaire di;
        di.insert(std::make_pair(ang,Ta));
        di.insert(std::make_pair(esp,Te));
        textes.insert(std::make_pair(Tf,di));
}
//---------------------------------------------------------------------------
        Traducteur::Traducteur()
{
        ajoute_une_entree(wxT(" contient "),wxT("  of  "),wxT(" contiene "));
        ajoute_une_entree(wxT(" par "),wxT(" by "),wxT(" por "));
        ajoute_une_entree(wxT(" répond:"),wxT(" answers:"),wxT(" contesta:"));
        ajoute_une_entree(wxT("&A propos"),wxT("&About"),wxT("&Acerca de"));
        ajoute_une_entree(wxT("&Aide"),wxT("&Help"),wxT("&Ayuda"));
        ajoute_une_entree(wxT("&Calcul"),wxT("&Compute"),wxT("&Calcula"));
        ajoute_une_entree(wxT("&Enregistre"),wxT("&Save"),wxT("&Guarda"));
        ajoute_une_entree(wxT("&Enregistrer"),wxT("&Save"),wxT("&Guardar"));
        ajoute_une_entree(wxT("&Interrompt"),wxT("&Cancel game"),wxT("&Parar"));
        ajoute_une_entree(wxT("&Lance une partie"),wxT("&Start game"),wxT("&Arrancar un partido"));
        ajoute_une_entree(wxT("&Langage"),wxT("&Language"),wxT("&Idioma"));
        ajoute_une_entree(wxT("&Machine<->Machine"),wxT("P&C vs PC"),wxT("&Máquina<->Máquina"));
        ajoute_une_entree(wxT("&Mode"),wxT("&Mode"),wxT("&Modo"));
        ajoute_une_entree(wxT("&Outils"),wxT("&Tools"),wxT("&Herramientas"));
        ajoute_une_entree(wxT("&Ouvrir"),wxT("&Open"),wxT("&Abrir"));
        ajoute_une_entree(wxT("&Personnalité"),wxT("&Profile"),wxT("&Perfil"));
        ajoute_une_entree(wxT("&Qualités de la grille"),wxT("&Grid's qualities"),wxT("&Qualidad de la reja"));
        ajoute_une_entree(wxT("&Quitter"),wxT("&Exit"),wxT("&Salir"));
        ajoute_une_entree(wxT("&Rubriques d'aide"),wxT("&help topics"),wxT("&Ayuda"));
        ajoute_une_entree(wxT("5  cases"),wxT("5  squares"),wxT("5 casillas"));
        ajoute_une_entree(wxT("10 cases"),wxT("10 squares"),wxT("10 casillas"));
        ajoute_une_entree(wxT("12 cases"),wxT("12 squares"),wxT("12 casillas"));
        ajoute_une_entree(wxT("décembre 2005 / mars 2024"),wxT("Dec 2005 / March 2024"),wxT("Diciembre 2005/Marzo 2020"));
        ajoute_une_entree(wxT("a joué"),wxT("played"),wxT("Ha tocado"));
        ajoute_une_entree(wxT("A l'eau!"),wxT("You missed!"),wxT("¡Falló!"));
        ajoute_une_entree(wxT("A propos"),wxT("About"),wxT("Acerca de"));
        ajoute_une_entree(wxT("A vous de jouer "),wxT("Your turn "),wxT("Le toca a usted"));
        ajoute_une_entree(wxT("Aide"),wxT("Help"),wxT("Ayuda"));
        ajoute_une_entree(wxT("Ajoute"),wxT("Add"),wxT("Añade"));
        ajoute_une_entree(wxT("Annule"),wxT("Cancel"),wxT("Cancela"));
        ajoute_une_entree(wxT("Anglais"),wxT("English"),wxT("Inglés"));
        ajoute_une_entree(wxT("Arrête"),wxT("Stop"),wxT("Para"));
        ajoute_une_entree(wxT("attendus"),wxT("expected"),wxT("Esperado"));
        ajoute_une_entree(wxT("Avertissement"),wxT("Disclaimer"),wxT("Advertencia"));
        ajoute_une_entree(wxT("Bataille navale"),wxT("Battleships"),wxT("Batalla naval"));
        ajoute_une_entree(wxT("batnavfra"),wxT("batnaveng"),wxT("batnavesp"));
        ajoute_une_entree(wxT("Bienvenue"),wxT("Welcome"),wxT("Bienvenida"));
        ajoute_une_entree(wxT("Bien essayé !"),wxT("Well ... you had to try !"),wxT("¡Siempre mejor tratar…!"));
        ajoute_une_entree(wxT("Bouton > pour lancer la partie"),wxT("Press > button to start the game"),wxT("Botón > para arrancar"));
        ajoute_une_entree(wxT("Case interdite"),wxT("Here? No way!"),wxT("Casilla prophibida"));
        ajoute_une_entree(wxT("cases"),wxT("squares"),wxT("Casillas"));
        ajoute_une_entree(wxT("Ce bateau est trop long"),wxT("it's too large a boat"),wxT("Este barco es demasiado largo"));
        ajoute_une_entree(wxT("Ce bateau n'existe pas"),wxT("no such boat in the fleet"),wxT("Este barco no existe"));
        ajoute_une_entree(wxT("C'est noté!"),wxT("Got it!"),wxT("¡Entendido!"));
        ajoute_une_entree(wxT("compacte"),wxT("packed"),wxT("Compacto"));
        ajoute_une_entree(wxT("Coulé!"),wxT("She sinks!"),wxT("¡Se hunde!"));
        ajoute_une_entree(wxT("coulé"),wxT("sinked"),wxT("Hundido"));
        ajoute_une_entree(wxT("coup suivant"),wxT("next turn"),wxT("Turno siguiente"));
        ajoute_une_entree(wxT("Cuirassé"),wxT("Iron clad"),wxT("Acorazado"));
        ajoute_une_entree(wxT("Defaut"),wxT("Default"),wxT("Por defecto"));
        ajoute_une_entree(wxT("déjà joué"),wxT("previously tried"),wxT("Ya lo tocó"));
        ajoute_une_entree(wxT("Déjà occupée"),wxT("yet selected"),wxT("Ya ocupada"));
        ajoute_une_entree(wxT("déjà touché"),wxT("double hit"),wxT("Ya golpeada"));
        ajoute_une_entree(wxT("Destroyer"),wxT("Destroyer"),wxT("Destructor"));
        ajoute_une_entree(wxT("DisclaimimageFra.png"),wxT("DisclaimimageEng.png"),wxT("DisclaimimageEsp.png"));
        ajoute_une_entree(wxT("Echap pour interrompre"),wxT("Esc Key to stop"),wxT("Esc para parar"));
        ajoute_une_entree(wxT("Efface personnalité"),wxT("Erase personality"),wxT("Borrar la personalidad"));
        ajoute_une_entree(wxT("Effacement de la liste ?"),wxT("Clear the list ?"),wxT("¿Borrar la lista?"));
        ajoute_une_entree(wxT("En cours: "),wxT("Checking: "),wxT("Probando:"));
        ajoute_une_entree(wxT("Enregistrer &sous..."),wxT("Save &as..."),wxT("Guardar &como"));
        ajoute_une_entree(wxT("Enregistrer les profiles actifs"),wxT("Save current profiles"),wxT("Almacenar los perfiles vigentes"));
        ajoute_une_entree(wxT("Erreur: format de fichier incorrect"),wxT("Error: invalid file type"),wxT("Error: archivo invalido"));
        ajoute_une_entree(wxT("Erreur: impossible d'ouvrir le fichier "),wxT("Error: unable to open the file "),wxT("Error: imposible abrir el archivo"));
        ajoute_une_entree(wxT("Escorteur"),wxT("Escort vessel"),wxT("Fragata"));
        ajoute_une_entree(wxT("Espagnol"),wxT("Spanish"),wxT("Español"));
        ajoute_une_entree(wxT("F&ichier"),wxT("F&iles"),wxT("A&rchivo"));
        ajoute_une_entree(wxT("Fermer"),wxT("Close"),wxT("Cerrar"));
        ajoute_une_entree(wxT("Fichier d'aide non trouvé\n"),wxT("Help file not found\n"),wxT("Archivo de ayuda no encontrado\n"));
        ajoute_une_entree(wxT("Fichiers batanav"),wxT("batanav files"),wxT("Archivos batanav"));
        ajoute_une_entree(wxT("Fichiers"),wxT("Files"),wxT("Archivos"));
        ajoute_une_entree(wxT("Fin de partie"),wxT("Game over"),wxT("Fin de partido"));
        ajoute_une_entree(wxT("flottille en construction"),wxT("shipyard work..."),wxT("Astillero ocupado"));
        ajoute_une_entree(wxT("flottille terminée, maintenant on joue"),wxT("fleet complete, let's play"),wxT("Flotilla completa, ahora se juega"));
        ajoute_une_entree(wxT("Forme bateaux"),wxT("boat's shape"),wxT("Tipo de barcos"));
        ajoute_une_entree(wxT("fumette"),wxT("weird"),wxT("raros"));
        ajoute_une_entree(wxT("Français"),wxT("French"),wxT("Francés"));
        ajoute_une_entree(wxT("gagne"),wxT("wins"),wxT("gana"));
        ajoute_une_entree(wxT("grille"),wxT("grid"),wxT("reja"));
        ajoute_une_entree(wxT("Grille de l'adversaire"),wxT("Challenger's grid"),wxT("Tablero del retador"));
        ajoute_une_entree(wxT("Il est plus facile de construire la flottille des grands vers les petits bateaux"),wxT("Easier to build the flotilla from the big units downward"),wxT("Más fácil construir la flotilla desde los gran barcos hacia los pequeños"));
        ajoute_une_entree(wxT("Il faut quand même  deux joueurs !"),wxT("You need at least one challenger !"),wxT("¡No valor sin un retador!"));
        ajoute_une_entree(wxT("Il manque un bateau!"),wxT("A boat is missing!"),wxT("¡Falta un barco!"));
        ajoute_une_entree(wxT("Il n'y a pas de solution"),wxT("No available solution"),wxT("No hay solución"));
        ajoute_une_entree(wxT("Il y AVAIT quelque chose ici!"),wxT("there WAS something here!"),wxT("¡Había ALGO aquí!"));
        ajoute_une_entree(wxT("Impossible !"),wxT("No way !"),wxT("¡Imposible!"));
        ajoute_une_entree(wxT("Impossible de construire le bateau"),wxT("Unable to build the boat"),wxT("Construcción del barco imposible"));
        ajoute_une_entree(wxT("Impossible de caser ce bateau"),wxT("No way !"),wxT("Colocar este baroc es imposible"));
        ajoute_une_entree(wxT("Impossible de trouver une case"),wxT("Unable to find a square"),wxT("No se puede encontrar una casilla"));
        ajoute_une_entree(wxT("Impossible! existe déjà!"),wxT("Try again! already present"),wxT("¡Imposible! Ya existe."));
        ajoute_une_entree(wxT("Impression"),wxT("Print"),wxT("Impresión"));
        ajoute_une_entree(wxT("Inconnu"),wxT("Unknown"),wxT("Desconocido"));
        ajoute_une_entree(wxT("inconnue"),wxT("unknown"),wxT("Desconocida"));
        ajoute_une_entree(wxT("inutile"),wxT("useless"),wxT("Inútil"));
        ajoute_une_entree(wxT("0<-- X jeu compact -->4"),wxT("0<-- X packed grid -->4"),wxT("0<-- X reja compacta -->4"));
        ajoute_une_entree(wxT("jeu compact"),wxT("packed grid"),wxT("Reja compacta"));
        ajoute_une_entree(wxT("Grille de l'adversaire connue à ce stade"),wxT("known grid of the challenger"),wxT("Tablero del oponente ya conocido"));
        ajoute_une_entree(wxT("jeu de "),wxT("grid of "),wxT("Tablero de"));
        ajoute_une_entree(wxT("jeu marginal"),wxT("peripheral grid"),wxT("Reja marginal"));
        ajoute_une_entree(wxT("La structure attendue est récapitulée ci-contre"),wxT("Present flotilla's structure is summarized beside"),wxT("La structura de la flotilla vigente está al lado"));
        ajoute_une_entree(wxT("Lance une partie"),wxT("Start game"),wxT("Arranca un partido"));
        ajoute_une_entree(wxT("Langue"),wxT("Language"),wxT("Idioma"));
        ajoute_une_entree(wxT("libre"),wxT("free-style"),wxT("libre"));
        ajoute_une_entree(wxT("M&achine<->Machine auto"),wxT("PC &vs PC auto"),wxT("M&áquina <->Máquina auto"));
        ajoute_une_entree(wxT("Machine <-> homme"),wxT("PC vs player"),wxT("Máquina <->Hombre"));
        ajoute_une_entree(wxT("Machine <-> Machine ("+Param_nb_de_boucles+" parties)"),wxT("PC vs PC "+Param_nb_de_boucles+" games)"),wxT("Máquina <->Máquina ("+Param_nb_de_boucles+" partidos)"));
        ajoute_une_entree(wxT("Machine <-> Machine"),wxT("PC vs PC"),wxT(" Máquina <->Máquina"));
        ajoute_une_entree(wxT("Machine <-> &homme"),wxT("&PC vs player"),wxT("Máquina <->Hombre"));
        ajoute_une_entree(wxT("Mauvais!"),wxT("Bad move!"),wxT("¡Qué torpe!"));
        ajoute_une_entree(wxT("Mode"),wxT("Mode"),wxT("Modo"));
        ajoute_une_entree(wxT("Navire fragmenté"),wxT("Broken ship"),wxT("Barco roto"));
        ajoute_une_entree(wxT("nb actuel"),wxT("present"),wxT("presente"));
        ajoute_une_entree(wxT("nom"),wxT("name"),wxT("nombre"));
        ajoute_une_entree(wxT("Non"),wxT("No"),wxT("No"));
        ajoute_une_entree(wxT("Nouv. nom"),wxT("New name"),wxT("Nuev. nbre"));
        ajoute_une_entree(wxT("nouveau joueur"),wxT("new player"),wxT("Nuevo jugador"));
        ajoute_une_entree(wxT("Nouvelle forme des bateaux:"),wxT("new shape for boats:"),wxT("Nueva forma de barcos"));
        ajoute_une_entree(wxT("Nouvelle grille"),wxT("new grid size"),wxT("Tipo de reja alterado"));
        ajoute_une_entree(wxT("Nouvelle partie"),wxT("New game"),wxT("Partido nuevo"));
        ajoute_une_entree(wxT("Nul! déjà jouée"),wxT("Nonsense! previously played"),wxT("¡Qué tontería!"));
        ajoute_une_entree(wxT("ou"),wxT("or"),wxT("o"));
        ajoute_une_entree(wxT("Oui"),wxT("Yes"),wxT("Sí"));
        ajoute_une_entree(wxT("Ouvrir un fichier de personnalités"),wxT("Open a profiles' file"),wxT("abrir un perfil"));
        ajoute_une_entree(wxT("Outils"),wxT("Tools"),wxT("Herramientas"));
        ajoute_une_entree(wxT("Partie interrompue"),wxT("game cancelled"),wxT("Partido interrumpido"));
        ajoute_une_entree(wxT("Personnalité"),wxT("Profile"),wxT("Perfil"));
        ajoute_une_entree(wxT("Précision"),wxT("Accuracy"),wxT("Precisión"));
        ajoute_une_entree(wxT("Pressez le bouton de validation pour confirmer les changements"),wxT("Press the button to confirm changes"),wxT("Cliqueen en el boton para confirmar los cambios"));
        ajoute_une_entree(wxT("purge la liste"),wxT("clear players' list"),wxT("Limpia la lista de jugadores"));
        ajoute_une_entree(wxT("Quelle idée se fait le joueur du type de grille de son adversaire"),wxT("Challenger's farorite grid type as seen by the player"),wxT("Tablero del retador tal como lo conoce el jugador"));
        ajoute_une_entree(wxT("Quitter"),wxT("Exit"),wxT("Salir"));
        ajoute_une_entree(wxT("réfléchit"),wxT("thinking..."),wxT("Pensando..."));
        ajoute_une_entree(wxT("Saisie incorrecte,essayez à nouveau"),wxT("invalid answer, try again"),wxT("Incorecto, trata de nuevo."));
        ajoute_une_entree(wxT("Saisissez votre nom ci_dessous"),wxT("Please, type your name below"),wxT("Por favor, escriba su nombre abajo"));
        ajoute_une_entree(wxT("Sauve le fichier en cours"),wxT("Save the current file"),wxT("Almacena el archivo vigente"));
        ajoute_une_entree(wxT("sans titre"),wxT("untitled"),wxT("sin título"));
        ajoute_une_entree(wxT("Supprime le joueur"),wxT("Delete the selected player"),wxT("Suprime el jugador seleccionado"));
        ajoute_une_entree(wxT("taille"),wxT("size"),wxT("Tamaño"));
        ajoute_une_entree(wxT("Tailles possibles pour la grille"),wxT("Allowed sizes for the chessboard"),wxT("Tamanos de tablero posibles"));
        ajoute_une_entree(wxT("tordue"),wxT("bent"),wxT("torcido"));
        ajoute_une_entree(wxT("tordus"),wxT("bent"),wxT("torcidos"));
        ajoute_une_entree(wxT("Touche Echap pour interrompre à la fin de la partie en cours"),wxT("Esc key to cancel at he end of the ongoing game"),wxT("Tecla Esc para el jruego al fin del partido en curso"));
        ajoute_une_entree(wxT("Touché!"),wxT("Hit!"),wxT("¡Golpeado!"));
        ajoute_une_entree(wxT("Tous fichiers"),wxT("All files"),wxT("Todos los archivos"));
        ajoute_une_entree(wxT("traditionnelle"),wxT("regular"),wxT("Tradicional"));
        ajoute_une_entree(wxT("Tricheur!"),wxT("Cheater!"),wxT("¡Fulero!"));
        ajoute_une_entree(wxT("Type de grille préféré par le joueur"),wxT("Player's favorite grid type"),wxT("Tipo de tablero preferido del jugador"));
        ajoute_une_entree(wxT("Type de grille de l'adversaire"),wxT("Challenger's favorite grid type"),wxT("Tipo de tableor del oponente"));
        ajoute_une_entree(wxT("Un bien mauvais coup!"),wxT("Nothing to be proud of!"),wxT("Menos dicho de esto, mejor ..."));
        ajoute_une_entree(wxT("Un second clic sur une case la supprime"),wxT("Clicking on an existing square deletes it"),wxT("Cliquear en una casilla la suprime"));
        ajoute_une_entree(wxT("valide changement"),wxT("Confirm change"),wxT("Confirma el cambio"));
        ajoute_une_entree(wxT("Valider"),wxT("Confirm"),wxT("Confirmar"));
        ajoute_une_entree(wxT("Vedette"),wxT("Torpedo boat"),wxT("Torpedero"));
        ajoute_une_entree(wxT("Votre grille"),wxT("Your grid"),wxT("Su reja"));
        ajoute_une_entree(wxT("Votre grille vue par l'adversaire"),wxT("Your grid as seen by your challenger"),wxT("Su reja tal como la ve el retador"));
        ajoute_une_entree(wxT("vous devez construire votre flottille"),wxT("you must build your fleet"),wxT("Tiene que construir su flotilla"));
}
//---------------------------------------------------------------------------
        langues& Traducteur::fixe_langue()
{
        static langues Langue_active=fr;
        return Langue_active;
}
//---------------------------------------------------------------------------
        //fixe la langue de départ
        void Traducteur::langue_demarrage()
{
        bool est_francais(true);
#if defined(__WXMSW__)
        // 1036 pour le français
        est_francais=(GetSystemDefaultLangID()==1036);
#elif defined(__UNIX__)
        wxString lg;
        wxGetEnv(wxT("LANG"),&lg);
        lg=lg.Left(2);
        est_francais=(lg==wxT("fr"));
#endif
        if (est_francais) fixe_langue()=fr;
                else fixe_langue()=ang;
}
//---------------------------------------------------------------------------
        wxString Traducteur::trad(wxString T)
{
        if (textes.find(T)==textes.end()) return T;
        langues L=fixe_langue();
        if (L==fr) return T;
        return textes[T][L];
}
//---------------------------------------------------------------------------
        wxString Traducteur::trad_tout(wxString T)
{
        wxString traduction=T;
        for(std::map<wxString,Dictionnaire>::iterator i=textes.begin();i!=textes.end();++i)
                if (T==i->first) traduction=trad(T);
                else  for(langues j=suivant(fr);j<=esp;j=suivant(j))
                        if (T==i->second[j])
                                traduction=trad(i->first);
        return traduction;
}
//---------------------------------------------------------------------------
//      Fin de l'objet Traducteur
//---------------------------------------------------------------------------
wxColor& Couleur_Fenetres_defaut()
{
        static wxColor couleur_fen=wxSystemSettings::GetColour(wxSYS_COLOUR_ACTIVEBORDER);
        return couleur_fen;
}
wxRect& Taille_Fenetres_defaut()
{
        //Fixe une position et une taille initiale
        // format pos.x, pos.y, Largeur, Hauteur
        static wxRect taille_fen(250,50,750,550);
        return taille_fen;
}
wxPoint FaitReelle_Pos(wxPoint posvirtuelle,wxWindow* fen)
{
        int X= fen->GetClientSize().GetWidth();
        int Y= fen->GetClientSize().GetHeight();
        return wxPoint(int(posvirtuelle.x*X/1000.0),int(posvirtuelle.y*Y/1000.0));
}
wxSize FaitReelle_Taille(wxSize Sizevirtuelle,wxWindow* fen)
{
        int X= fen->GetClientSize().GetWidth();
        int Y= fen->GetClientSize().GetHeight();
        Sizevirtuelle.Scale(float(X/1000.0),float(Y/1000.0));
        return Sizevirtuelle;
}
void FixeFontEtTaille(wxWindow* fen)
{
        wxFont Police(fen->GetFont());
        Police.SetPointSize(8);
        fen->SetFont(Police);
}
//---------------------------------------------------------------------------
        PalettePerso::PalettePerso():clDkGray(128,128,128),clCream(255,251,240),clAqua(0,255,255),clLtGray(192,192,192),clRed(255,0,0),clBlack(0,0,0),
                                    clYellow(255,255,0),clLime(0,255,0)
        {
        }
//---------------------------------------------------------------------------
void RenommeEnfants(wxWindow* Sujet)
{
        Traducteur tr;
        wxToolTip* tt;
        wxFrame* p_frame;
        wxTextCtrl* p_txtctrl;
        p_txtctrl=dynamic_cast<wxTextCtrl*>(Sujet);
        // Vérifie que ce n'est pas un wxTextCtrl
        // ne fait rien si c'est le cas
        if (p_txtctrl==NULL) // Si la fenêtre est un TextCtrl sous Windows le renommage semble provoquer un clear()
        {
            // Sous Windows Setlabel ajuste correctement le titre des "Frames' mais pas sous Linux
            // d'où la nécessité de distinguer WxXindow et wxFrame
            p_frame=dynamic_cast<wxFrame*>(Sujet);
            if (p_frame!=NULL) // C'est une wxWFrame
                p_frame->SetTitle(tr.trad_tout(p_frame->GetTitle()));
            else // C'est une simple wxWindow
                Sujet->SetLabel(tr.trad_tout(Sujet->GetLabel()));
            tt=Sujet->GetToolTip();
            if (tt!=NULL)
                Sujet->SetToolTip(tr.trad_tout(tt->GetTip()));
            // Même chose pour les enfants
            wxWindowList list;
            list=Sujet->GetChildren();
            wxWindowList::compatibility_iterator node;
            for (node = list.GetFirst(); node; node = node->GetNext() )
                {
                wxWindow *current = node->GetData();
                RenommeEnfants(current);
                }
        }
}
