#ifndef FICHEPERSOJOUEUR_H_INCLUDED
#define FICHEPERSOJOUEUR_H_INCLUDED

#include <wx/wx.h>
/*
    Batanav est un jeu de bataille navale très classique.
    Copyright (C) 2005 - 2009-2020 Vial Jean-Luc Annecy
    Contact email: vial.frjl@free.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class Tgraphique;
class Tpersonnalite;
class TTableau_personnalite;

class FichePerso : public wxFrame
{

public:

        // Controles
        static const long idBoutonPurgePerso;
        void OnBoutonPurgePerso(wxCommandEvent& event);
        wxButton* BoutonPurgePerso;
        static const long idBoutonSupprime;
        void OnBoutonSupprime(wxCommandEvent& event);
        wxButton* BoutonSupprime;
        static const long idChoixPerso;
        void OnChoixPerso(wxCommandEvent& event);
        void OnChoixPersoTexte(wxCommandEvent& event);
        wxComboBox* ChoixPerso;
        // Labels
        static const long idLabCompac;
        wxStaticText* LabCompac;
        static const long idLabMargin;
        wxStaticText* LabMargin;
        static const long idLabScore;
        wxStaticText* LabScore;
        // Le constructeur
        FichePerso(wxWindow* parent,wxWindowID idfichePerso,Tpersonnalite* perso1,Tpersonnalite* perso2);
        void Met_a_jour_ChoixPerso();

// Le destructeur
~FichePerso();
private:

        static const long idCanvas5;
        Tgraphique* Canvas5;
        TTableau_personnalite* abaque1;
        static const long idCanvas6;
        Tgraphique* Canvas6;
        TTableau_personnalite* abaque2;

        void OnQuit1(wxCloseEvent& event);
        void rafraichit();
        void OnPaint(wxPaintEvent& event);
        int largeurFP;


        DECLARE_EVENT_TABLE()
};

#endif // FICHEPERSOJOUEUR_H_INCLUDED
